// Copyright (C) 2004, Brian Enigma <enigma at netninja.com>
// This file is part of iGallery.
//
// iGallery is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// iGallery is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Foobar; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
package org.ninjasoft.igallery.swingui;

import java.util.*;
import javax.swing.event.*;
import javax.swing.table.TableModel;
import org.ninjasoft.igallery.data.*;

/**
 * Table model to represent the Gallery albums
 * @author enigma
 */
public class GalleryTableModel implements TableModel {
    Vector listeners = new Vector();
    Vector albumList = new Vector();
    
    public void setAlbumList(Vector list) {
        this.albumList = list;
        tellChanged();
    }
    public void tellChanged() {
        TableModelEvent e = new TableModelEvent(this);
        for (Iterator i = listeners.iterator(); i.hasNext(); )
            ((TableModelListener) i.next()).tableChanged(e);
    }
    public void addTableModelListener(TableModelListener l) {
        listeners.add(l);
    }
    public Class getColumnClass(int i) {
        return String.class;
    }
    public int getColumnCount() {
        return 2;
    }
    public String getColumnName(int i) {
        if (i==0)
            return "Name";
        return "Photo Count";
    }
    public int getRowCount() {
        return albumList.size();
    }
    public Object getValueAt(int row, int column) {
        GalleryAlbum album = (GalleryAlbum) albumList.get(row);
        if (column == 0)
            return album.getName();
        int count = album.getPictureCount();
        if (count >= 0)
            return Integer.toString(count);
        return "?";
    }
    public boolean isCellEditable(int arg0, int arg1) {
        return false;
    }
    public void removeTableModelListener(TableModelListener l) {
        listeners.remove(l);
    }
    public void setValueAt(Object arg0, int arg1, int arg2) {
        
    }
}
